if not AltManager then return end

local quests_old, questsC = { }, { }

function AltManager:QuestUpdateHandle()
		local quests = {}
		local i = 1
		while GetQuestLogTitle(i) do
			local _, _, _, _, isHeader, _, isComplete, _, questID = GetQuestLogTitle(i)
			if not isHeader then 
				quests[questID] = true
				if isComplete then questsC[questID] = true end
			end
			i = i + 1
		end
		
		if tC(quests_old) > tC(quests) then
			-- Lost a quest
			for k,v in pairs(quests_old) do
				if not (quests[k]) then
					if questsC[k] then
						self:Quest_Completed(k)
						questsC[k] = false
					else
						self:Quest_Abandoned(k)
					end
				end
			end
		elseif tC(quests_old) < tC(quests) then
			-- Gained a quest
			for k,v in pairs(quests) do
				if not (quests_old[k]) then
					self:Quest_Gained(k)
				end
			end
		end
		
		quests_old = quests
	-- end
end

function tC(array)
	if (array) then
		local i = 0
		for k,v in pairs(array) do
			i = i+1
		end
		return i
	end
	return 0
end